#!/usr/local/bin/perl

open (ERR, "@ARGV[0]");
open (MSG, "@ARGV[1]");
$diff = 0;

$errline = <ERR>;
$msgline = <MSG>;

while ($errline and $msgline) {
    ($errdr, $errrest) = split("@", $errline);
    ($_, $errrace) = split(":", $errrest, 2);
    ($msgdr, $msgrest) = split("@", $msgline);
    ($_, $msgrace) = split(":", $msgrest, 2);
    if (($errdr ne $msgdr) or ($errrace ne $msgrace)) {
	print "@ARGV[0]", ' >> ', $errdr, $errrace;
	print "@ARGV[1]", ' << ', $msgdr, $msgrace;
	print "-" x 80, "\n";
	$diff++;
    }
    $errline = <ERR>;
    $msgline = <MSG>;
}

if ($errline) {
  do {
    ($errdr, $errrest) = split("@", $errline);
    ($_, $errrace) = split(":", $errrest, 2);
    print "@ARGV[0]", ' >> ', $errdr, $errrace;
    print "-" x 80, "\n";
    $diff++;
  }
  while ($errline = <ERR>);
}

if ($msgline) {
  do {
    ($msgdr, $msgrest) = split("@", $msgline);
    ($_, $msgrace) = split(":", $msgrest, 2);
    print "@ARGV[1]", ' << ', $msgdr, $msgrace;
    print "-" x 80, "\n";
    $diff++;
  } while ($msgline = <MSG>);
}

close(ERR);
close(MSG);

exit $diff;
