/*
 * $Id: cilk-nd-cilk2c.h,v 1.1.2.4 1997/09/05 05:16:01 fengmd Exp $
 */

/*
 * $Log: cilk-nd-cilk2c.h,v $
 * Revision 1.1.2.4  1997/09/05 05:16:01  fengmd
 * FREE_ID changes to 2.  Fix cilk2c for Cilk_free var problem.
 *
 * Revision 1.1.2.3  1997/08/29 07:38:37  fengmd
 * Merge malloc/free checker, race report hashing, garbage collection.
 *
 * Revision 1.1.2.2  1997/02/15 02:46:40  fengmd
 * Add Id and Log
 *
 */

/*
 * Copyright (c) 1996 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to use, copy, modify, and distribute the Software without
 * restriction, provided the Software, including any modified copies made
 * under this license, is not distributed for a fee, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE MASSACHUSETTS INSTITUTE OF TECHNOLOGY BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 * CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Except as contained in this notice, the name of the Massachusetts
 * Institute of Technology shall not be used in advertising or otherwise
 * to promote the sale, use or other dealings in this Software without
 * prior written authorization from the Massachusetts Institute of
 * Technology.
 *  
 */

/*
 * checking protype, called from cilk2c'ed Cilk program
 */
#ifdef CILK_NDL

#define _READ_CHECK(p, size, v) \
  Cilk_internal_read_check(p, size, __LINE__, __FILE__, #v)
#define _READ_CHECK4(p, v) \
  Cilk_internal_read_check4(p, __LINE__, __FILE__, #v)
#define _READ_CHECK8(p, v) \
  Cilk_internal_read_check8(p, __LINE__, __FILE__, #v)
#define _WRITE_CHECK(p, size, op_type, v) \
  Cilk_internal_write_check(p, size, op_type, __LINE__, __FILE__, #v)
#define _WRITE_CHECK4(p, op_type, v) \
  Cilk_internal_write_check4(p, op_type, __LINE__, __FILE__, #v)
#define _WRITE_CHECK8(p, op_type, v) \
  Cilk_internal_write_check8(p, op_type, __LINE__, __FILE__, #v)

#define _READ_CHECK_VALUE(p, size, v) \
  Cilk_internal_read_check(&(p), size, __LINE__, __FILE__, #v)
#define _READ_CHECK_VALUE4(p, v) \
  Cilk_internal_read_check4(&(p), __LINE__, __FILE__, #v)
#define _READ_CHECK_VALUE8(p, v) \
  Cilk_internal_read_check8(&(p), __LINE__, __FILE__, #v)
#define _WRITE_CHECK_VALUE(p, size, op_type, v) \
  Cilk_internal_write_check(&(p), size, op_type, __LINE__, __FILE__, #v)
#define _WRITE_CHECK_VALUE4(p, op_type, v) \
  Cilk_internal_write_check4(&(p), op_type, __LINE__, __FILE__, #v)
#define _WRITE_CHECK_VALUE8(p, op_type, v) \
  Cilk_internal_write_check8(&(p), op_type, __LINE__, __FILE__, #v)

#define _SPAWNVAR_CHECK(p, size, op_type, f, v) \
  Cilk_internal_spawnvar_check(&(p), size, op_type, f, __LINE__, __FILE__, #v)

#define _MALLOC_CHECK(p)      Cilk_nd_malloc(p, __LINE__, __FILE__, "malloc")
#define _FREE_CHECK(p, v)     Cilk_nd_free(p, __LINE__, __FILE__, #v)
#define _MEMALIGN_CHECK(p, s) Cilk_nd_memalign(p, s, __LINE__, __FILE__, "memalign")
#define _CALLOC_CHECK(p, s)   Cilk_nd_calloc(p, s, __LINE__, __FILE__, "calloc")
#define _REALLOC_CHECK(p, s)  Cilk_nd_realloc(p, s, __LINE__, __FILE__, "realloc")
#define _VALLOC_CHECK(p)      Cilk_nd_valloc(p, __LINE__, __FILE__, "valloc")

#else

#define _READ_CHECK(p, size) Cilk_internal_read_check(p, size)
#define _READ_CHECK4(p) Cilk_internal_read_check4(p)
#define _READ_CHECK8(p) Cilk_internal_read_check8(p)
#define _WRITE_CHECK(p, size, op_type) \
  Cilk_internal_write_check(p, size, op_type)
#define _WRITE_CHECK4(p, op_type) Cilk_internal_write_check4(p, op_type)
#define _WRITE_CHECK8(p, op_type) Cilk_internal_write_check8(p, op_type)

#define _READ_CHECK_VALUE(p, size) Cilk_internal_read_check(&(p), size)
#define _READ_CHECK_VALUE4(p) Cilk_internal_read_check4(&(p))
#define _READ_CHECK_VALUE8(p) Cilk_internal_read_check8(&(p))
#define _WRITE_CHECK_VALUE(p, size, op_type) \
  Cilk_internal_write_check(&(p), size, op_type)
#define _WRITE_CHECK_VALUE4(p, op_type) \
  Cilk_internal_write_check4(&(p), op_type)
#define _WRITE_CHECK_VALUE8(p, op_type) \
  Cilk_internal_write_check8(&(p), op_type)

#define _SPAWNVAR_CHECK(p, size, op_type, f) \
  Cilk_internal_spawnvar_check(&(p), size, op_type, f)

#define _MALLOC_CHECK(p)      Cilk_nd_malloc(p)
#define _FREE_CHECK(p)        Cilk_nd_free(p)
#define _MEMALIGN_CHECK(p, s) Cilk_nd_memalign(p, s)
#define _CALLOC_CHECK(p, s)   Cilk_nd_calloc(p, s)
#define _REALLOC_CHECK(p, s)  Cilk_nd_realloc(p, s)
#define _VALLOC_CHECK(p)      Cilk_nd_valloc(p)

#endif

